#api hooks
require 'sketchup.rb'

#for debugging  
#Sketchup.send_action "showRubyPanel:"

#menu item to launch panel 

#UI.messagebox("about to draw battery packs")
wd=UI::WebDialog.new( "WebDialog", true, "WebDialogg", 400, 300, 100, 100, false )
wd.add_action_callback("first_ac") do |js_wd, message|
#UI::messagebox( 'I\'m Ruby. JavaScript : "' + message + '"' )
draw_batts if message == "DrawRequest"
end
html_path = Sketchup.find_support_file "draw_batt/battInfoGetter.html" ,"Plugins"
wd.set_file( html_path )
wd.show()


def draw_batts
	filename = Sketchup.find_support_file "draw_batt/battData.csv" ,"Plugins"
	file = File.new(filename, 'r')
	 
	xpos = 0 #where we start drawing
	file.each_line("\n") do |row|
	columns = row.split(",")
	print file.lineno
	print ": "
	xpos  = draw_cells(columns, file.lineno-3, xpos) if (file.lineno > 3)

 end
 end
	
def draw_cells (batt_info, batt_number, x1)
	cells_series = batt_info[9].to_i
	cells_parallel = batt_info[10].to_i
	cm2inch =  0.393700787
	length = batt_info[5].to_f * cm2inch
	width = batt_info[6].to_f * cm2inch
	height = batt_info[7].to_f * cm2inch
	x1 = x1.to_f
	return if length*width*height <= 0
	#for visual clarity
	if length*cells_series > width*cells_parallel
		cells_y = cells_series
		cells_x = cells_parallel
	else 
		cells_y = cells_parallel
		cells_x = cells_series
		tmp = width
		width = length
		length = tmp
		
	end


	model = Sketchup.active_model
	entities = model.entities	
	print length  
	print " "
	print width
	print " "
	print height
	print "\n"
#		points
	
	
	x2 = width + x1 
	y1 = 0
	y2 = length
	z = 0

	entities = Sketchup.active_model.entities
	txt_point = Geom::Point3d.new x1, y1-3, -3
	text_string = batt_info[0] + " " + batt_info[14] + " Wh"
	#{(batt_info[14].to_f/1000)}.to_s + "kWh $" +  batt_info[13] + " " + {(batt_info[14].to_f/batt_info[16].to_f)}.to_s +"kg"
	text  = entities.add_text text_string, txt_point
	if batt_info[21].to_f == 0.907 # we are dealing with a cylindrical cell
		radius = (batt_info[6].to_f ** 0.5)*cm2inch
		
		centerpoint = Geom::Point3d.new x1+radius, radius, 0
		vect = Geom::Vector3d.new 0,0,1
		vect2 = vect.normalize!
		circle = entities.add_circle centerpoint, vect2, radius
	
		new_face = entities.add_face circle
		g = entities.add_group( new_face ) # group all entities
		cell_inst = g.to_component() # convert group to component instance
		new_face.pushpull height * -1
	
		for cell_p in 1..cells_x
			for cell_s in 1..cells_y
				new_transformation = Geom::Transformation.new([x1,y1+(cell_s-1)*radius*2,0])
				entities.add_instance(cell_inst.definition, new_transformation)
			end
			x1 = x1 + radius*2
		end
	else	
		pt1 = [x1, y1, z]
		pt2 = [x2, y1, z]
		pt3 = [x2, y2, z]
		pt4 = [x1, y2, z]
		new_face = entities.add_face pt1, pt2, pt3, pt4

	
		g = entities.add_group( new_face ) # group all entities
		cell_inst = g.to_component() # convert group to component instance
		new_face.pushpull height * -1
		for cell_p in 1..cells_x
			for cell_s in 1..cells_y
				new_transformation = Geom::Transformation.new([x1,y1+(cell_s-1)*length,0])
				entities.add_instance(cell_inst.definition, new_transformation)
			end
			x1 = x1 + width
		end
	end


	
	return x1 +10
	# vector = Geom::Vector3d.new 0,1,0
 #t = Geom::Transformation.translation vector
	#for cell in 1..cells
	
	#end
end 